cabal-install-solver-3.12.1.0: The command-line interface for Cabal and Hackage.

Safe Haskell | None
Language | Haskell2010

Distribution.Solver.Types.SolverId

Synopsis

- data SolverId
  - = PreExistingId {
    - solverSrcId :: PackageId
    - solverInstId :: UnitId
    }
  - | PlannedId {
    - solverSrcId :: PackageId
    }

# Documentation

data SolverId Source #

The solver can produce references to existing packages or packages we plan to install. Unlike `ConfiguredId` we don't yet know the `UnitId` for planned packages, because it's not the solver's job to compute them.

Constructors

PreExistingId |

Fields

- solverSrcId :: PackageId
- solverInstId :: UnitId

PlannedId |

Fields

- solverSrcId :: PackageId

#### Instances

Instances details

Package SolverId Source # |
Instance details Defined in Distribution.Solver.Types.SolverId Methods packageId :: SolverId -> PackageIdentifier Source #
Structured SolverId Source # |
Instance details Defined in Distribution.Solver.Types.SolverId Methods structure :: Proxy SolverId -> Structure Source # structureHash' :: Tagged SolverId MD5
Binary SolverId Source # |
Instance details Defined in Distribution.Solver.Types.SolverId Methods put :: SolverId -> Put Source # get :: Get SolverId Source # putList :: [SolverId] -> Put Source #
Generic SolverId Source # |

Instance details

Defined in Distribution.Solver.Types.SolverId

Associated Types

type Rep SolverId |

Instance details

Defined in Distribution.Solver.Types.SolverId

type Rep SolverId = D1 ('MetaData "SolverId" "Distribution.Solver.Types.SolverId" "cabal-install-solver-3.12.1.0-5dSETZK2idVHohhzkfJS3u" 'False) (C1 ('MetaCons "PreExistingId" 'PrefixI 'True) (S1 ('MetaSel ('Just "solverSrcId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageId) :*: S1 ('MetaSel ('Just "solverInstId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 UnitId)) :+: C1 ('MetaCons "PlannedId" 'PrefixI 'True) (S1 ('MetaSel ('Just "solverSrcId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageId)))

Methods

from :: SolverId -> Rep SolverId x Source #

to :: Rep SolverId x -> SolverId Source #

Show SolverId Source # |
Instance details Defined in Distribution.Solver.Types.SolverId Methods showsPrec :: Int -> SolverId -> ShowS Source # show :: SolverId -> String Source # showList :: [SolverId] -> ShowS Source #
Eq SolverId Source # |
Instance details Defined in Distribution.Solver.Types.SolverId Methods (==) :: SolverId -> SolverId -> Bool Source # (/=) :: SolverId -> SolverId -> Bool Source #
Ord SolverId Source # |

Instance details

Defined in Distribution.Solver.Types.SolverId

Methods

compare :: SolverId -> SolverId -> Ordering Source #

(<) :: SolverId -> SolverId -> Bool Source #

(<=) :: SolverId -> SolverId -> Bool Source #

(>) :: SolverId -> SolverId -> Bool Source #

(>=) :: SolverId -> SolverId -> Bool Source #

max :: SolverId -> SolverId -> SolverId Source #

min :: SolverId -> SolverId -> SolverId Source #

type Rep SolverId Source # |

Instance details

Defined in Distribution.Solver.Types.SolverId

type Rep SolverId = D1 ('MetaData "SolverId" "Distribution.Solver.Types.SolverId" "cabal-install-solver-3.12.1.0-5dSETZK2idVHohhzkfJS3u" 'False) (C1 ('MetaCons "PreExistingId" 'PrefixI 'True) (S1 ('MetaSel ('Just "solverSrcId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageId) :*: S1 ('MetaSel ('Just "solverInstId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 UnitId)) :+: C1 ('MetaCons "PlannedId" 'PrefixI 'True) (S1 ('MetaSel ('Just "solverSrcId") 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 PackageId)))